## consensuscore2 0.12.0

=== CMakeLists.txt ===
########################################################################
# CMake build script for PacBioConsensus library.
########################################################################

cmake_policy(SET CMP0048 NEW)  # lets us set the version in project()
project(PacBioConsensus VERSION 0.12.0 LANGUAGES CXX C)
cmake_minimum_required(VERSION 3.0)

# set magic variable
set(ROOT_PROJECT_NAME ${PROJECT_NAME} CACHE STRING "root project name")

# required packages
if (NOT Boost_INCLUDE_DIRS)
    find_package(Boost 1.58.0 REQUIRED)
endif()

# main project paths
set(PacBioConsensus_RootDir           ${PacBioConsensus_SOURCE_DIR})
set(PacBioConsensus_IncludeDir        ${PacBioConsensus_RootDir}/include)
set(PacBioConsensus_LibDir            ${PacBioConsensus_RootDir}/lib)
set(PacBioConsensus_SourceDir         ${PacBioConsensus_RootDir}/src)
set(PacBioConsensus_SwigDir           ${PacBioConsensus_RootDir}/swig)
set(PacBioConsensus_TestsDir          ${PacBioConsensus_RootDir}/tests)

file(MAKE_DIRECTORY                   ${PacBioConsensus_LibDir})

# find the git sha1
list(APPEND CMAKE_MODULE_PATH "${PacBioConsensus_RootDir}/cmake")
include(FindGitSha1)
find_git_sha1(CC2_GIT_SHA1)

configure_file(
    ${PacBioConsensus_IncludeDir}/pacbio/consensus/Version.h.in
    ${PacBioConsensus_IncludeDir}/pacbio/consensus/Version.h
)

file(GLOB_RECURSE PacBioConsensus_CPP "${PacBioConsensus_SourceDir}/*.cpp")
file(GLOB_RECURSE PacBioConsensus_HPP "${PacBioConsensus_IncludeDir}/*.h")

# shared CXX flags for src & tests
include(CheckCXXCompilerFlag)
set(PacBioConsensus_CXX_FLAGS "-std=c++11 -Wall -pedantic -msse3")

# silence gmock warning
check_cxx_compiler_flag("-Wno-unused-variable" HAS_NO_UNUSED_VARIABLE)
if(HAS_NO_UNUSED_VARIABLE)
    set(PacBioConsensus_CXX_FLAGS "${PacBioConsensus_CXX_FLAGS} -Wno-unused-variable")
endif(HAS_NO_UNUSED_VARIABLE)

# includes
include_directories(. ${PacBioConsensus_IncludeDir})
include_directories(SYSTEM
    ${Boost_INCLUDE_DIRS}
)

# make release with debug the default, helps tests pass by being fast enough
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build,
      options are: Debug Release Profile RelWithDebInfo" FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

# flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${PacBioConsensus_CXX_FLAGS}")

# libpbconsensus.a
add_library(pbconsensus STATIC
    ${PacBioConsensus_CPP}
    ${PacBioConsensus_HPP}
)
set_target_properties(pbconsensus PROPERTIES
    ARCHIVE_OUTPUT_DIRECTORY ${PacBioConsensus_LibDir}
)

# support static registration
if(APPLE)
    set(PRE_LINK -force_load)
elseif(UNIX)
    SET(PRE_LINK -Wl,-whole-archive)
    SET(POST_LINK -Wl,-no-whole-archive)
endif()

# because we can be a dependency, set this in the parent scope if so
if(${ROOT_PROJECT_NAME} STREQUAL "PacBioConsensus")
    set(PBCONSENSUS_LIBRARIES ${PRE_LINK} pbconsensus ${POST_LINK})
else()
    set(PBCONSENSUS_LIBRARIES ${PRE_LINK} pbconsensus ${POST_LINK} PARENT_SCOPE)
endif()

# swig
if (PYTHON_SWIG)
    add_subdirectory(${PacBioConsensus_SwigDir})
endif()

# testing
add_subdirectory(${PacBioConsensus_TestsDir})

=== tests/CMakeLists.txt ===

# pthread
find_package(Threads)

# gmock/gtest
set(GMOCK_RootDir    ${PacBioConsensus_RootDir}/third-party/gmock-1.7.0)
set(GMOCK_IncludeDir ${GMOCK_RootDir})

file(GLOB           GMOCK_CC    "${GMOCK_RootDir}/*.cc")
file(GLOB_RECURSE   GMOCK_H     "${GMOCK_RootDir}/*.h")

# output directory
file(MAKE_DIRECTORY  ${PacBioConsensus_TestsDir}/bin)

include_directories(
    ${PacBioConsensus_IncludeDir}
)

# Generate paths for test data
#configure_file(
#    ${PacBioConsensus_TestsDir}/TestData.h.in
#    ${PacBioConsensus_TestsDir}/TestData.h
#)

include_directories(SYSTEM
    ${Boost_INCLUDE_DIRS}
    ${GMOCK_IncludeDir}
)

file(GLOB PacBioConsensusTests_CPP "*.cpp")

add_executable(test_pbconsensus EXCLUDE_FROM_ALL
    ${PacBioConsensusTests_CPP}
    ${GMOCK_CC}
    ${GMOCK_H}
)
set_target_properties(test_pbconsensus PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${PacBioConsensus_TestsDir}/bin
)
target_link_libraries(test_pbconsensus
    ${PBCONSENSUS_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
    ${CMAKE_DL_LIBS}
)

if (${ROOT_PROJECT_NAME} STREQUAL "PacBioConsensus")
    add_custom_target(check test_pbconsensus)
endif()

=== debian/changelog ===
consensuscore2 (0.12.0-1) unstable; urgency=medium

  * Initial release (Closes: #829510)
    (based on git ce50b30 - 2016-06-29)

 -- Afif Elghraoui <afif@debian.org>  Sun, 03 Jul 2016 16:43:26 -0700

=== debian/control ===
Source: consensuscore2
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Afif Elghraoui <afif@debian.org>
Build-Depends:
	debhelper (>=9),
	dh-python,
	dh-exec,
	cmake,
	swig,
	libboost-dev,
# Python2
	python-all,
	python-all-dev,
	python-setuptools,
	python-numpy (>= 1.6.0),
# Python3
	python3-all,
	python3-all-dev,
	python3-setuptools,
	python3-numpy (>= 1.6.0),
Standards-Version: 3.9.8
Homepage: https://github.com/PacificBiosciences/ConsensusCore2
Vcs-Git: https://anonscm.debian.org/git/debian-med/consensuscore2.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/consensuscore2.git

Package: libconsensuscore2-dev
Section: libdevel
Architecture: any-amd64 any-i386
Depends:
	${shlibs:Depends},
	${misc:Depends},
Description: generate consensus sequences for PacBio data -- development files
 ConsensusCore2 embodies core C++ routines underlying the Arrow HMM
 algorithm for PacBio multi-sequence consensus.  Arrow is the successor
 to the Quiver model---a CRF model that was embodied in the
 ConsensusCore C++ library. Compared to Quiver, the Arrow model is more
 statistically principled and easier and more robust to train.
 .
 This package installs the headers and static library.

Package: python-consensuscore2
Section: python
Architecture: any-amd64 any-i386
Depends:
	${python:Depends},
	${shlibs:Depends},
	${misc:Depends},
Description: generate consensus sequences for PacBio data -- Python 2
 ConsensusCore2 embodies core C++ routines underlying the Arrow HMM
 algorithm for PacBio multi-sequence consensus.  Arrow is the successor
 to the Quiver model---a CRF model that was embodied in the
 ConsensusCore C++ library. Compared to Quiver, the Arrow model is more
 statistically principled and easier and more robust to train.
 .
 This package installs the library for Python 2.

Package: python3-consensuscore2
Section: python
Architecture: any-amd64 any-i386
Depends:
	${python3:Depends},
	${shlibs:Depends},
	${misc:Depends},
Description: generate consensus sequences for PacBio data -- Python 3
 ConsensusCore2 embodies core C++ routines underlying the Arrow HMM
 algorithm for PacBio multi-sequence consensus.  Arrow is the successor
 to the Quiver model---a CRF model that was embodied in the
 ConsensusCore C++ library. Compared to Quiver, the Arrow model is more
 statistically principled and easier and more robust to train.
 .
 This package installs the library for Python 3.

## consensuscore2 0.13.0+20160719

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 ########################################################################
 
 cmake_policy(SET CMP0048 NEW)  # lets us set the version in project()
-project(PacBioConsensus VERSION 0.12.0 LANGUAGES CXX C)
+project(PacBioConsensus VERSION 0.13.0 LANGUAGES CXX C)
 cmake_minimum_required(VERSION 3.0)
 
 # set magic variable

=== swig/CMakeLists.txt ===

# output directory
file(MAKE_DIRECTORY  ${PacBioConsensus_SwigDir}/lib)

configure_file(
    ${PacBioConsensus_RootDir}/swig/ConsensusCore2.i.in
    ${PacBioConsensus_RootDir}/swig/ConsensusCore2.i
)

include_directories(
    ${PacBioConsensus_IncludeDir}
)

include(FindPythonPaths)
find_python_inc(PYTHON_INCLUDE_DIRS)
find_numpy_inc(NUMPY_INCLUDE_DIRS)

# Generate paths for test data
#configure_file(
#    ${PacBioConsensus_TestsDir}/TestData.h.in
#    ${PacBioConsensus_TestsDir}/TestData.h
#)

include_directories(SYSTEM
    ${Boost_INCLUDE_DIRS}
    ${PYTHON_INCLUDE_DIRS}
    ${NUMPY_INCLUDE_DIRS}
)

# fPIC is required by a the majority of Linux systems,
# and the original ConsensusCore used it by default.
# We could use python -c "print(sysconfig.get_config_var('CCSHARED'))",
# but it's honestly unnecessary and requires providing PYTHON_EXECUTABLE
target_compile_options(pbconsensus PUBLIC -fPIC)
add_compile_options(-fPIC)

# ConsensusCore2_wrap.cxx
set(SWIG_COMMAND swig CACHE PATH "swig path")

add_custom_command(OUTPUT ConsensusCore2_wrap.cxx
    COMMAND ${SWIG_COMMAND} -Wextra -c++ -python -builtin -module ConsensusCore2
        -I${PacBioConsensus_IncludeDir}
        -o ${CMAKE_BINARY_DIR}/swig/ConsensusCore2_wrap.cxx -outdir ${CMAKE_BINARY_DIR}/swig
        ${PacBioConsensus_SwigDir}/ConsensusCore2.i
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_BINARY_DIR}/swig/ConsensusCore2.py
        ${PacBioConsensus_SwigDir}/lib/__init__.py
)

# _ConsensusCore2.so
add_library(_ConsensusCore2 MODULE
    ConsensusCore2_wrap.cxx
)

target_link_libraries(_ConsensusCore2
    ${PBCONSENSUS_LIBRARIES}
)

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    target_link_libraries(_ConsensusCore2 "-Wl,-undefined,dynamic_lookup")
endif()

set_target_properties(_ConsensusCore2 PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${PacBioConsensus_SwigDir}/lib
    PREFIX ""
)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,10 @@
 
 # pthread
 find_package(Threads)
+
+if (EXTENSIVE_TESTING)
+    add_definitions(-DEXTENSIVE_TESTING=1)
+endif()
 
 # gmock/gtest
 set(GMOCK_RootDir    ${PacBioConsensus_RootDir}/third-party/gmock-1.7.0)

=== debian/changelog ===
consensuscore2 (0.13.0+20160719-1) unstable; urgency=medium

  * Imported Upstream version 0.13.0+20160719
  * Drop obsolete patch
  * Allow setup.py to work with both Python 2.x and 3.x
    (Closes: #829622)

 -- Afif Elghraoui <afif@debian.org>  Sun, 24 Jul 2016 00:13:58 -0700

=== debian/control ===
--- 
+++ 
@@ -14,11 +14,13 @@
 	python-all,
 	python-all-dev,
 	python-setuptools,
+	python-six,
 	python-numpy (>= 1.6.0),
 # Python3
 	python3-all,
 	python3-all-dev,
 	python3-setuptools,
+	python3-six,
 	python3-numpy (>= 1.6.0),
 Standards-Version: 3.9.8
 Homepage: https://github.com/PacificBiosciences/ConsensusCore2

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1
export LC_ALL=C.UTF-8

export PYBUILD_NAME=consensuscore2

%:
	dh $@ --with python2,python3 --buildsystem=pybuild

# The python packages need to be installed as soon as they're built,
# otherwise, changing the version will overwrite the previous attempt.
define finalize
dh_auto_configure --package=$1
dh_auto_build --package=$1
dh_auto_install --package=$1
endef

# Configuration and build is done in one step.
override_dh_auto_configure:

override_dh_auto_build:
	$(call $(finalize),python-consensuscore2)
	$(call $(finalize),python3-consensuscore2)
# The static library is already built at this point.

override_dh_auto_clean:
	dh_auto_clean --buildsystem=cmake
	$(RM) include/pacbio/consensus/Version.h
	$(RM) swig/ConsensusCore2.i
	$(RM) lib/libpbconsensus.a

override_dh_clean:
	dh_clean -O--buildsystem=cmake

# The actual build uses a temporary directory for each invocation of setup.py,
# so we run a separate build for the purposes of testing.
override_dh_auto_test:
	dh_auto_configure --buildsystem=cmake
	dh_auto_build --buildsystem=cmake
	dh_auto_test --buildsystem=cmake

override_dh_python2:
	dh_python2
	dh_numpy

override_dh_python3:
	dh_python3
	dh_numpy3

# The python2 and python3 packages have the same compiled module, so their
# debug packages conflict (as reported by lintian).
# This unsuccessfully attempts to prevent producing the dbgsym package
# for one of them.
# See https://lists.debian.org/debian-devel/2015/12/msg00262.html
#override_dh_strip:
#	dh_strip --package python3-consensuscore2 --no-ddebs
#	dh_strip --remaining-packages

=== debian/watch ===
version=4

# Upstream does not tag releases.
# Their Git history has to be manually inspected for milestone commits.
